define("local_treestudyplan/studyplan-report-components",["exports","./util/string-helper","core/ajax","core/notification","./util/debugger","core/config","./treestudyplan-components"],(function(_exports,_stringHelper,_ajax,_notification,_debugger,_config,_treestudyplanComponents){function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0,_notification=_interopRequireDefault(_notification),_debugger=_interopRequireDefault(_debugger),_config=_interopRequireDefault(_config),_treestudyplanComponents=_interopRequireDefault(_treestudyplanComponents);const debug=new _debugger.default("treestudyplan-viewer");Math.PI;function conditions(item){const course=item.course,list=[];if(course.completion)for(const cmp of course.competencies)list.push(cmp);else if(course.completion)for(const cnd of course.completion.conditions)for(const itm of cnd.items)list.push(itm);else if(course.grades)for(const g of course.grades)g.selected&&list.push(g);return list}var _default={install(Vue){Vue.use(_treestudyplanComponents.default);let strings=(0,_stringHelper.load_strings)({report:{loading:"loadinghelp@core",studyplan_past:"studyplan_past",studyplan_present:"studyplan_present",studyplan_future:"studyplan_future",back:"back"},invalid:{error:"error"},header:{overall:"overall",students:"students@core"},studentresults:{completion_incomplete:"completion_incomplete",completion_failed:"completion_failed",completion_pending:"completion_pending",completion_progress:"completion_progress",completion_completed:"completion_completed",completion_good:"completion_good",completion_excellent:"completion_excellent",student_not_tracked:"student_not_tracked"}});Vue.component("q-studyplanreport",{props:{structure:{type:Object}},data:()=>({students:[],studentresults:{},expansioninfo:{periods:{},lines:{},items:{}},groupinfo:{},sorting:{name:"asc"}}),created(){this.loadStudents()},watch:{structure:{immediate:!0,handler(structure){for(const period of structure.periods){const pid=period.period.id;this.expansioninfo.periods[pid]||(this.$set(this.expansioninfo.periods,pid,{expanded:!1}),this.$set(this.expansioninfo.lines,period.period.id,{}));for(const line of period.lines){const lid=line.line.id;this.expansioninfo.lines[lid]||this.$set(this.expansioninfo.lines[pid],lid,{expanded:!0});for(const item of line.items)this.expansioninfo.items[item.id]||this.$set(this.expansioninfo.items,item.id,{expanded:!1})}}}}},computed:{sortedstudents(){return this.students},resultColCount(){let count=0;for(const period of this.structure.periods){const pid=period.period.id;if(this.expansioninfo.periods[pid].expanded)for(const line of period.lines){const lid=line.line.id;if(this.expansioninfo.lines[pid][lid])for(const item of line.items)this.expansioninfo.items[item.id]?count+=1+conditions(item).length:count+=1;else count+=1}else count+=1}return count}},methods:{loadStudents(){const self=this;(0,_ajax.call)([{methodname:"local_treestudyplan_all_associated_grouped",args:{studyplan_id:this.structure.studyplan.id}}])[0].then((function(response){self.students=response;for(const group of self.students){self.$set(self.groupinfo,group.label,{expand:!0});for(const student of group.users)self.$set(self.studentresults,student.id,{loading:!0,results:[]}),(0,_ajax.call)([{methodname:"local_treestudyplan_get_report_data",args:{pageid:self.structure.page.id,userid:student.id,firstperiod:self.structure.firstperiod,lastperiod:self.structure.lastperiod}}])[0].then((function(response){self.studentresults[student.id].loading=!1,self.studentresults[student.id].results=response})).catch(_notification.default.exception)}})).catch(_notification.default.exception)},expansionChanged(parm,id,val){parm="p"==parm[0]?"periods":"l"==parm[0]?"lines":"items",debug.info("Expansion Changed",parm,id,val),"lines"==parm?this.expansioninfo[parm][id[0]][id[1]].expanded=val:this.expansioninfo[parm][id].expanded=val}},template:"\n            <table class='q-studyplanreport'>\n                <q-header \n                    :sorting='sorting' \n                    :structure='structure'\n                    :expansion='expansioninfo'\n                    @expansion='expansionChanged'\n                ></q-header>\n                <template v-for=\"group in sortedstudents\">\n                    <q-groupheading v-if=\"group.users\" :label=\"group.label\" :groupinfo=\"groupinfo[group.label]\"></q-groupheading>\n                    <template v-if='group.users && groupinfo[group.label].expand'>\n                        <q-studentresults v-for=\"student in group.users\"\n                            :student='student'\n                            :structure='structure'\n                            :results='studentresults[student.id].results'\n                            :loading='studentresults[student.id].loading'\n                            :expansion='expansioninfo'\n                            ></q-studentresults>\n                    </template>\n                </template>\n            </table>\n            "}),Vue.component("q-header",{props:{structure:{type:Object},sorting:{type:Object},expansion:{type:Object}},data:()=>({text:strings.header}),computed:{},methods:{conditions:item=>function(item){const course=item.course,list=[];if(course.completion)for(const cmp of course.competencies)list.push({name:cmp.title});else if(course.completion)for(const cnd of course.completion.conditions)for(const itm of cnd.items)list.push({name:itm.title});else if(course.grades)for(const g of course.grades)g.selected&&(debug.info("...included"),list.push({name:g.name}));return debug.info("Returning list",list),list}(item),colspanPeriod(period){const pid=period.period.id;if(debug.info("Checking period expansion",period,this.expansion.periods),this.expansion.periods[pid].expanded){let sum=0;for(const l of period.lines)sum+=this.colspanLine(period,l);return sum}return 1},colspanLine(period,line){const pid=period.period.id,lid=line.line.id;if(this.expansion.lines[pid][lid].expanded){let sum=0;for(const i of line.items)sum+=this.colspanItem(i);return sum}return 1},colspanItem(item){if(this.expansion.items[item.id].expanded){return 1+this.conditions(item).length}return 1}},mounted(){},updated(){},template:"\n            <thead class='q-header'>\n                <tr> \x3c!-- period heading --\x3e\n                    <th rowspan='4' class='q-studentname'><span>{{text.students}}</span></th>\n                    <th v-for=\"p in structure.periods\" \n                        class='q-period-heading'\n                        :colspan='colspanPeriod(p)'\n                        :rowspan='(expansion.periods[p.period.id].expanded)?1:4'\n                        ><a  v-if=\"expansion.periods[p.period.id].expanded\"\n                            href='#' @click.prevent=\"$emit('expansion','periods',p.period.id,false);\"\n                            ><i class='fa fa-minus-square'></i></a\n                        ><a  v-else\n                            href='#' @click.prevent=\"$emit('expansion','periods',p.period.id,true);\"\n                            ><i class='fa fa-plus-square'></i></a\n                        >&nbsp;{{ p.period.fullname}}\n                    </th>\n                </tr>\n                <tr> \x3c!-- line heading --\x3e\n                    <template v-for=\"p in structure.periods\">\n                        <template v-if=\"expansion.periods[p.period.id].expanded\">              \n                            <th v-for=\"l in p.lines\"\n                                class='q-line-heading'\n                                :colspan=\"colspanLine(p,l)\"\n                                ><span v-html=\"l.line.shortname\"></span\n                            ></th>\n                        </template>\n                    </template>\n                </tr>\n                <tr> \x3c!-- item heading --\x3e\n                    <template v-for=\"p in structure.periods\">      \n                        <template v-if=\"expansion.periods[p.period.id].expanded\">                 \n                            <template v-for=\"l in p.lines\">\n                                <template v-if=\"expansion.lines[p.period.id][l.line.id].expanded\">\n                                    <th v-for=\"item in l.items\"\n                                        :class=\"'q-item-heading ' + ((expansion.items[item.id].expanded)?'expanded':'collapsed')\"\n                                        :colspan=\"colspanItem(item)\"\n                                        :rowspan='(expansion.items[item.id].expanded)?1:2'\n                                        ><a  v-if=\"expansion.items[item.id].expanded\"\n                                            href='#' @click.prevent=\"$emit('expansion','items',item.id,false);\"\n                                                ><i class='fa fa-minus-square'></i></a\n                                        ><a  v-else\n                                            href='#' @click.prevent=\"$emit('expansion','items',item.id,true);\"\n                                                ><i class='fa fa-plus-square'></i></a\n                                        >&nbsp;<span v-html=\"item.course.displayname\"></span\n                                    ></th>\n                                </template>\n                            </template>\n                        </template>\n                    </template>\n                </tr>\n                <tr> \x3c!-- condition heading --\x3e\n                    <template v-for=\"p in structure.periods\">\n                        <template v-if=\"expansion.periods[p.period.id].expanded\">     \n                            <template v-for=\"l in p.lines\">\n                                <template v-if=\"expansion.lines[p.period.id][l.line.id].expanded\">\n                                    <template v-for=\"item in l.items\">\n                                        <template v-if=\"expansion.items[item.id].expanded\">\n                                            <th class='q-condition-heading overall'\n                                                ><span>{{ text.overall }}</span></th>\n                                            <th v-for=\"c in conditions(item)\"\n                                                class='q-condition-heading'\n                                                ><span v-html=\"c.name\"></span\n                                            ></th>\n                                        </template>\n                                    </template>\n                                </template>\n                            </template>\n                        </template>\n                    </template>\n                </tr>\n            </thead>\n            "}),Vue.component("q-groupheading",{props:{structure:{type:Object}},data:()=>({}),computed:{},methods:{},template:"\n            <tr class='q-groupheading'>\n\n            </tr>\n            "}),Vue.component("q-studentresults",{props:{student:{type:Object},structure:{type:Object},results:{type:Array},loading:{type:Boolean,default:!1},expansion:{type:Object}},data:()=>({text:strings.studentresults}),computed:{},methods:{useritems(line){const list=[];for(const item of line.items){let newitm=item;for(const itm of this.results)if(item.id==itm.id){newitm=itm;break}list.push(newitm)}return list},conditions:item=>conditions(item)},template:'\n            <tr class=\'q-student-results\'>\n                <td class=\'q-studentname\'><span>{{student.firstname}} {{student.lastname}}</span></td>\n                <template v-for="p in structure.periods">\n                    <template v-if="expansion.periods[p.period.id].expanded">     \n                        <template v-for="l in p.lines">\n                            <template v-if="expansion.lines[p.period.id][l.line.id].expanded">\n                                <template v-for="item in useritems(l)">\n                                    <td class=\'q-result overall\'\n                                        ><q-courseresult\n                                            :item="item"\n                                            :student="student"\n                                            :loading="loading"\n                                        ></q-courseresult\n                                    ></td>\n                                    <template v-if="expansion.items[item.id].expanded">\n                                        <td v-for="(c,idx) in conditions(item)"\n                                            class=\'q-result\'\n                                            ><q-conditionresult\n                                                :item="item"\n                                                :conditionidx="idx"\n                                                :student="student"\n                                                :loading="loading"\n                                            ></q-conditionresult\n                                        ></td>\n                                    </template>\n                                </template>\n                            </template>\n                            <td v-else class=\'q-result collapsed\'>&nbsp;</td>\n                        </template>\n                    </template>\n                    <td v-else class=\'q-result collapsed\'>&nbsp;</td>\n                </template>\n            </tr>\n            '}),Vue.component("q-courseresult",{props:{student:{type:Object},item:{type:Object},loading:{type:Boolean,default:!1}},data:()=>({text:strings.studentresults}),computed:{hasprogressinfo(){const course=this.item.course;return!!course.enrolled&&(course.completion||course.competency||course.grades)},completion_icon(){switch(this.item.completion){default:return"circle-o";case"pending":return"question-circle";case"failed":return"times-circle";case"progress":return"exclamation-circle";case"completed":case"good":case"excellent":return"check-circle"}}},methods:{},template:'\n            <span class=\'q-courseresult\'>\n                <template v-if="loading">\n                    <div class="spinner-border spinner-border-sm text-info" role="status"></div>\n                </template>\n                <template v-else-if=\'!item.course.enrolled\'>\n                    <i v-b-popover.top\n                        class="fa fa-exclamation-triangle t-not-enrolled-alert"\n                        :title="text.student_not_tracked"></i>\n                </template>\n                <template v-else>\n                    <i v-b-popover.top\n                        :class="\'fa fa-\'+completion_icon+\n                                \' r-completion-\'+item.completion"\n                        :title="text[\'completion_\'+item.completion]"></i>\n                </template>\n            </span>\n            '}),Vue.component("q-conditionresult",{props:{student:{type:Object},item:{type:Object},loading:{type:Boolean,default:!1},conditionidx:{type:Number}},data:()=>({text:strings.studentresults}),computed:{conditions(){return conditions(this.item)},condition(){return this.conditionidx>=0&&this.conditionidx<this.conditions.length?this.conditions[this.conditionidx]:null},hasprogressinfo(){const course=this.item.course;return!!course.enrolled&&(course.completion||course.competency||course.grades)}},methods:{completion_icon(completion){switch(completion){default:return"circle-o";case"pending":return"question-circle";case"failed":return"times-circle";case"progress":return"exclamation-circle";case"completed":case"good":case"excellent":return"check-circle"}}},template:'\n            <span class=\'q-conditionresult\'>\n                <template v-if="loading">\n                    <div class="spinner-border spinner-border-sm text-info" role="status"></div>\n                </template>\n                <template v-else-if=\'!item.course.enrolled\'>\n                    <i v-b-popover.top\n                        class="fa fa-exclamation-triangle t-not-enrolled-alert"\n                        :title="text.student_not_tracked"></i>\n                </template>\n                <template v-else>\n                    <i v-b-popover.top\n                        :class="\'fa fa-\'+completion_icon(item.completion)+\n                                \' r-completion-\'+item.completion"\n                        :title="text[\'completion_\'+item.completion]"></i>\n                </template>\n            </span>\n            '})}};return _exports.default=_default,_exports.default}));

//# sourceMappingURL=studyplan-report-components.min.js.map